using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Xml;
using System.Data.OleDb;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;

public partial class BindingToDataSet : System.Web.UI.Page
{
  #region PrivateVariables
  private OleDbConnection oledbConnection;
  private OleDbDataAdapter oledbAdapter1;
  private DataSet dsDataset1 = new DataSet();
  private OleDbCommand oledbCommand1 = new OleDbCommand();
  private string strConnection;
  #endregion

  public void Page_Init(object sender, System.EventArgs e)
  {
    BindGrid();
    //Adding Primary key column.
    GridTableDescriptor maintd = this.GridGroupingControl1.TableDescriptor;
    maintd.PrimaryKeyColumns.Add("CategoryID");
    //Binding the Grid
    this.GridGroupingControl1.DataBind();
    oledbConnection.Close();
  }
  
  public void BindGrid()
  {
    string selectCommand;

    //Specifies connection information to the OleDbConnection.
    strConnection = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + MapPath("\\Syncfusion\\Web\\Data\\nwind.mdb"); 
    selectCommand = "SELECT CategoryID,CategoryName,Description FROM Categories";
    oledbConnection = new OleDbConnection(strConnection);
    oledbAdapter1 = new OleDbDataAdapter(selectCommand, oledbConnection);
    
    //Open the connection to the database.
    oledbConnection.Open();
    
    //Filing the records from the database to dataset. 
    oledbAdapter1.Fill(dsDataset1, "Categories");
  
    //Connect the Grid to the datasource using Datasource property.
    this.GridGroupingControl1.DataSource = dsDataset1;
    this.GridGroupingControl1.DataMember = "Categories";
  }
  
  protected void updateDatabase()
  {
    //Getting the current record from GridGroupingControl.
    Record r = this.GridGroupingControl1.Table.CurrentRecord;
    oledbConnection = new OleDbConnection(strConnection);
    oledbConnection.Open();    
    string updatecommand = "UPDATE Categories SET CategoryName =' " + r.GetValue("CategoryName") + " '  ,Description =' " + r.GetValue("Description") + " ' WHERE CategoryID=" + r.GetValue("CategoryID") + " ";
    oledbCommand1 = new OleDbCommand(updatecommand, oledbConnection);
    this.oledbAdapter1.UpdateCommand = oledbCommand1;

     //Changes to get persisted in database.
     this.oledbAdapter1.Update(dsDataset1, "Categories");

    oledbConnection.Close();
  }
  protected void CallbackPanel1_CallbackRefresh(object sender, Syncfusion.Web.UI.WebControls.Tools.CancellableCallbackEventArgs e)
    {
        if (e.CallbackArgument.ToString() == "Update")
        {
            this.GridGroupingControl1.Table.EndEdit();
            //Calling the Update database where the data's are persisted in database.
            updateDatabase();
            //Binding the Grid.
            this.GridGroupingControl1.DataBind();
        }
        else
        {
            //Edit the Currently selected record.
            this.GridGroupingControl1.Table.BeginEdit();   
        }
    }
}
